package com.ecep.contract.ds.vendor.service;

import java.util.Locale;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.cache.annotation.Caching;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import com.ecep.contract.IEntityService;
import com.ecep.contract.QueryService;
import com.ecep.contract.VendorType;
import com.ecep.contract.constant.ServiceConstant;
import com.ecep.contract.ds.vendor.repository.VendorTypeLocalRepository;
import com.ecep.contract.model.VendorTypeLocal;
import com.ecep.contract.util.SpecificationUtils;
import com.fasterxml.jackson.databind.JsonNode;

@Lazy
@Service
@CacheConfig(cacheNames = "vendor-type")
public class VendorTypeService implements IEntityService<VendorTypeLocal>, QueryService<VendorTypeLocal> {
    @Lazy
    @Autowired
    private VendorTypeLocalRepository repository;

    @Override
    public Page<VendorTypeLocal> findAll(JsonNode paramsNode, Pageable pageable) {
        Specification<VendorTypeLocal> spec = null;
        if (paramsNode.has(ServiceConstant.KEY_SEARCH_TEXT)) {
            spec = getSpecification(paramsNode.get(ServiceConstant.KEY_SEARCH_TEXT).asText());
        }

        if (paramsNode.has("type")) {
            spec = SpecificationUtils.and(spec, (root, query, builder) -> builder.equal(root.get("type"), VendorType.valueOf(paramsNode.get("type").asText())));
        }

        // field
        spec = SpecificationUtils.andFieldEqualParam(spec, paramsNode, "lang", "value");
        return findAll(spec, pageable);
    }

    @Cacheable(key = "#p0")
    @Override
    public VendorTypeLocal findById(Integer id) {
        return repository.findById(id).orElse(null);
    }

    @Override
    public Page<VendorTypeLocal> findAll(Specification<VendorTypeLocal> spec, Pageable pageable) {
        return repository.findAll(spec, pageable);
    }

    @Cacheable(key = "'all-'+#p0.toLanguageTag()")
    public Map<VendorType, VendorTypeLocal> findAll(Locale locale) {
        return repository.getCompleteMapByLocal(locale.toLanguageTag());
    }

    @Override
    public Specification<VendorTypeLocal> getSpecification(String searchText) {
        if (!StringUtils.hasText(searchText)) {
            return null;
        }
        return (root, query, builder) -> {
            return
                    // builder.or(
                    builder.like(root.get("type"), "%" + searchText + "%")
                    // )
                    ;
        };
    }

    @Caching(evict = {
            @CacheEvict(key = "#p0.id"),
            @CacheEvict(key = "'all-'+#p0.getLang()")
    })
    @Override
    public void delete(VendorTypeLocal entity) {
        repository.delete(entity);
    }

    @Caching(evict = {
            @CacheEvict(key = "#p0.id"),
            @CacheEvict(key = "'all-'+#p0.getLang()")
    })
    @Override
    public VendorTypeLocal save(VendorTypeLocal entity) {
        return repository.save(entity);
    }
}
